<?php

namespace Controller;

use Exception;
use PDOException;
use Config\DataManagement;

/**
 * Permet de gérer l'appel des controllers en fonction de l'action et du rôle de l'utilisateur
 */
class FrontController
{
    /**
     * Définit le comportement de la classe à sa création, on appelle le bon controller en fonction de l'action
     * et du rôle de la personne qui souhaite réaliser cette action (utilisateur, administrateur...).
     */

    public function __construct()
    {
        $listControllers = array("\\Controller\\ControllerCandidate", "\\Controller\\ControllerAdmin");

        global $rep, $views;
        $dVueError = array();

        try {
            $action = $_REQUEST['action'] ? $action = $_REQUEST['action'] : (new ControllerCandidate())->goToForm();
            foreach ($listControllers as $controller) {
                if (method_exists($controller, $action)) {
                    (new $controller)->$action(); // Si oui, on appelle cette fonction
                }
            }
        } catch (PDOException|Exception $e) {
            $dVueError[] = "Erreur innatendue !"; // Ecriture du message d'erreur
            echo "ERREUUUUUR";
        }

        exit(0);
    }
}
